/* eslint-disable */
import {
 Http, IDictionary, Metadata, Loader,
} from '@zeedhi/core';
import {
  AlertService, DialogService, LoadingService, Select, Text,
} from '@zeedhi/common';
import { Utilities } from '@/util/Utilities';
export class TabBillingParametersController {

  public BPController = Loader.getInstance('BusinessPartnerController');

  public mountInformation() {
    const NRPARCNEGOCIO = this.BPController.currentRow.NRPARCNEGOCIO;
    LoadingService.show();
     Http.post('/getBillingParameter', { NRPARCNEGOCIO }).then((response: IDictionary) => {
      response.data.dataset.parameter.forEach((data: IDictionary) => {
        Metadata.getInstance<Text>('NRPARAMFATURA').text = data.NRPARAMFATURA;
        Metadata.getInstance<Select>('form-filial').setValue(data.CDFILIALFATURA);
        Metadata.getInstance<Select>('form-invoiceSeries').setValue(data.CDSERIENF);
        LoadingService.hide();
      });
    }).catch((error: any) => {
      Utilities.showErrorMessage(error);
      LoadingService.hide();
    });
  }

  public saveBillingParameter() {
    const SERIENF = Metadata.getInstance<Select>('form-invoiceSeries').value;
    const NRPARAMFATURA = Metadata.getInstance<Text>('NRPARAMFATURA').text;
    LoadingService.show();
    Http.post('/billingParameter', {
      NRPARCNEGOCIO: this.BPController.currentRow.NRPARCNEGOCIO,
      NRPARAMFATURA: (NRPARAMFATURA === '') ? null : NRPARAMFATURA,
      CDFILIALFATURA: Metadata.getInstance<Select>('form-filial').value,
      CDSERIENF: (SERIENF === null) ? null : SERIENF.CDSERIE,
      CDEMPRESA: (SERIENF === null) ? null : SERIENF.CDEMPRESA,
      CDINSCESTA: (SERIENF === null) ? null : SERIENF.CDINSCESTA,
      CDINSCMUNI: (SERIENF === null) ? null : SERIENF.CDINSCMUNI,
      CDOPERADOR: localStorage.getItem('CDOPERADOR'),
    }).then((response) => {
        this.alertMessages('Paramêtro de Faturamento salvo com sucesso!', 'success');
        Metadata.getInstance<Text>('NRPARAMFATURA').text = response.data.dataset.parameter[0];
        //this.mountInformation();
        LoadingService.hide();
    }).catch((error: any) => {
      Utilities.showErrorMessage(error);
      LoadingService.hide();
    });
  }

  public alertMessages(message: string, type: string) {
    AlertService.show({
      name: 'basic-alert',
      text: message,
      top: true,
      left: false,
      timeout: 3000,
      color: type,
    });
  }

  public dialogMessage(message: string) {
    DialogService.show({
      name: 'warning-dialog',
      type: 'warning',
      title: 'Erro!',
      text: message,
    });
  }
}